/* Copyright 1998-2017 Research Foundation State University of New York   */

/* This file is part of QUB Online.                                       */

/* QUB Online is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Online is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Online program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */

#ifndef QUBX_UTIL_H
#define QUBX_UTIL_H

#include "qubfast.h"

#ifdef __cplusplus
  extern "C" {
#endif

    void QUBFAST_API qubx_QtoPe(double *Q, double *Pe, int n);
    void QUBFAST_API qubx_QtoQe(double *Q, int n, int *clazz, double tdead, double *Qe);
    void QUBFAST_API qubx_expm(int n, double *A, double *Q, double t);
    void QUBFAST_API qubx_QtoQflux(int n, double *A, double *Q);
    void QUBFAST_API qubx_MeanFirstPassage(int n, double *A, double *Q, double sampling);
    void QUBFAST_API qubx_FirstLatencies(double* A, double* pEq, double dt, int n, double* FL);
    
    // returns na == number of states in class c == number of components
    // outputs:
    //   pdf[nbin*(1+na)]; first sum, then each component
    //   tau[na], amp[na]
    int QUBFAST_API qubx_mil_pdf(int n, double *Q, int *clazz, int a, double tdMS, int nbin, float *bins, float *pdf, float *tau, float *amp);

#ifdef __cplusplus
  }
#endif

#endif
